package polyglot.ext.op;

import polyglot.ast.*;
import polyglot.types.*;
import polyglot.util.*;
import polyglot.visit.*;
import polyglot.frontend.*;

import polyglot.ext.op.Lexer;
import polyglot.ext.op.Grm;

import java.util.*;
import java.io.*;

public class ExtensionInfo extends polyglot.ext.jl.ExtensionInfo {
    public String defaultFileExtension() {
	return "jop";
    }

    protected NodeFactory createNodeFactory() {
	return new OPNodeFactory();
    }

    protected TypeSystem createTypeSystem() {
	return new OPTypeSystem();
    }

    public Parser parser(Reader reader, FileSource source, ErrorQueue eq) {
        Lexer lexer = new Lexer(reader, source.name(), eq);
        Grm grm = new Grm(lexer, ts, nf, eq);
        return new CupParser(grm, source, eq);
    }

    public static final Pass.ID CAST_REWRITE = new Pass.ID("cast-rewrite");

    public List passes(Job job) {
        List l = super.passes(job);
        beforePass(l, Pass.PRE_OUTPUT_ALL,
                  new VisitorPass(CAST_REWRITE,
                                  job, new OPCastRewriter(job, ts, nf)));
        return l;
    }

    static { Topics t = new Topics(); }
}
