package polyglot.ext.polyj.ast;

import polyglot.ast.*;

/**
 * A <code>PolyJConstructorCall</code> is an immutable representation of
 * a direct call to a constructor of a class in the form of <code>super(...)</code>
 * or <code>this(...)</code>.  It consists of the kind of the call and a list of
 * expressions to be parameters of the call.  A constructor call statement may also
 * contain an expression providing the context in which it is executed.  This AST node
 * is extended because the constructors in parametrized classes change to include a where
 * class, and thus calls to the constructor must be appropriately translated.
 **/
public interface PolyJConstructorCall extends ConstructorCall { }
