package polyglot.ext.polyj.ast;

import polyglot.ast.*;
import polyglot.types.*;
import polyglot.util.*;
import polyglot.visit.*;

import polyglot.ext.jl.ast.*;
import polyglot.ext.polyj.extension.*;
import polyglot.ext.polyj.types.*;
import polyglot.ext.polyj.visit.*;

public class PolyJInitializer_c extends Initializer_c implements PolyJInitializer {
        
    public PolyJInitializer_c(Position pos, Flags flags, Block body) {
        super( pos, flags, body);
    }
    
    public void translate(CodeWriter w, Translator tr) {
	Context c = tr.context();                                                       
        PolyJTypeSystem ts = (PolyJTypeSystem) tr.typeSystem();
	
        ClassType curClass = c.currentClass();
	boolean isParameterized = ts.needsWhereObject(curClass);

        if (flags().isStatic() && isParameterized) {
            int myNum = ((PolyJInitializerExt)del()).initNum();
            String adIntName = PolyJTranslator.adapterInterfaceShortName(curClass);
            w.write("static void $init$" + myNum + "(" + adIntName + " $W) ");
            printBlock(body, w, tr);
        } else {
            super.translate(w, tr);
	}
    }    
}
