package polyglot.ext.polyj.ast;

import polyglot.ext.polyj.types.*;
import polyglot.ext.polyj.visit.*;

import polyglot.ext.jl.ast.*;

import polyglot.ast.*;
import polyglot.types.*;
import polyglot.util.*;
import polyglot.visit.*;

import java.util.*;

/** 
 * A <code>PolyJLocalDecl</code> is an immutable
 * representation of a variable declaration, which consists of a type, one or
 * more variable names, and possible initilization expressions.
 */
public class PolyJLocalDecl_c extends LocalDecl_c implements PolyJLocalDecl {

    /**
     * Creates a new <code>PolyJLocalDecl</code>.
     */
    public PolyJLocalDecl_c(Position pos,
                            Flags flags,
                            TypeNode type,
                            String name,
                            Expr init) {
        super( pos, flags, type, name, init);
    }
    
    public void dump(CodeWriter w) {
        w.write( "POLYJ LOCAL DECL");
        w.write( " < " + flags().toString() + "> ");
    }
}
