package polyglot.ext.polyj.parse;

import polyglot.ast.*;
import polyglot.visit.*;
import polyglot.types.*;
import polyglot.util.*;
import polyglot.parse.*;

import polyglot.ext.polyj.ast.*;

import java.util.*;

/**
 * An <code>Array</code> represents a <code>Parse</code> of the form "P[]".  
 * This must be an array type, although the base of that type is still ambiguous.
 */  
public class Array extends Parse {
    TypeNode prefix;

    public Array(BaseParser parser, Position pos, TypeNode prefix) {
        super(parser, pos);
        this.prefix = prefix;
    }

    public TypeNode toType() throws Exception {
        return nf.ArrayTypeNode(pos, prefix);
    }

    public Receiver toReceiver() throws Exception { 
        return toType(); 
    }
    
    public Prefix toPrefix() throws Exception {
        return toType();
    }
    
    public String toString() {
        return prefix + "[]";    
    }
    
    public Parse prepend(Parse base) throws Exception {
        List l = new LinkedList();
        l.add(this.toAmbSub());
        return new Inst(parser, pos, base.toType(), l);
    }
    
    public Receiver toParam() throws Exception {
        return toType();
    }
    
}
