package polyglot.ext.pure;

import polyglot.ext.pure.parse.Lexer_c;
import polyglot.ext.pure.parse.Grm;
import polyglot.ext.pure.ast.*;
import polyglot.ext.pure.types.*;

import polyglot.ast.*;
import polyglot.types.*;
import polyglot.util.*;
import polyglot.visit.*;
import polyglot.frontend.*;
import polyglot.main.*;

import java.util.*;
import java.io.*;

/**
 * Extension information for pure extension.
 *
 * Methods and constructors can be declared "pure".  A pure method
 * can call only other pure methods and pure constructors.
 * Assignments to fields and arrays are not allowed in pure methods or
 * constructors, except assignments to fields of "this" are allowed in
 * constructors.
 */
public class ExtensionInfo extends polyglot.ext.jl.ExtensionInfo {
    static {
        // force Topics to load
        Topics t = new Topics();
    }

    public String defaultFileExtension() {
        return "pur";
    }

    public String compilerName() {
        return "purec";
    }

    public Parser parser(Reader reader, FileSource source, ErrorQueue eq) {
        Lexer_c lexer = new Lexer_c(reader, source.name(), eq);
        Grm grm = new Grm(lexer, ts, nf, eq);
        return new CupParser(grm, source, eq);
    }

    protected NodeFactory createNodeFactory() {
        return new PureNodeFactory_c();
    }
    protected TypeSystem createTypeSystem() {
        return new PureTypeSystem_c();
    }

    public List passes(Job job) {
        List passes = super.passes(job);
        // TODO: add passes as needed by your compiler
        return passes;
    }

}
